
var CONTAINER_VERTICAL = 1;
var CONTAINER_HORIZONTAL = 2;

function LayoutElement()
{
	this.fSize = "0%";
	this.fOrientation = CONTAINER_HORIZONTAL;
	this.fSubElements = new Array(0);
	this.fURL = "";
	this.fName = "";
	this.fScrolling = "no";
	this.fShowing = true;
	this.fIsContainer = false;
	this.fAddSrc = true;
}

function LayoutElement_WriteHTML(document)
{
	if (this.fIsContainer) {
		document.write('<frameset ');
		if (this.fOrientation == CONTAINER_HORIZONTAL)
			document.write('cols = "');
		else
			document.write('rows = "');

		// Write Sizes
		var index;
		var first = true;
		for (index = 0; index < this.fSubElements.length; index++) {
			var subelement = this.fSubElements[index];
			if (subelement.ShouldWriteHTML()) {
				if (!first)
					document.write(', ');
				else
					first = false;
	
				document.write(subelement.fSize);
			}
		}

		document.writeln('" name = "' + this.fName + '" border=0 frameborder=0 framespacing=0>');

		// Recursively write frame contents
		for (index = 0; index < this.fSubElements.length; index++) {
			var subelement = this.fSubElements[index];
			
			// Skip elements that aren't visible, or containers that have no visible
			// elements
			if (subelement.ShouldWriteHTML())
				subelement.WriteHTML(document);
		}
			
		document.writeln('</frameset>');

	} else {
		// Write a frame
		document.write('<frame ');
		if (this.fURL.length > 0 && this.fAddSrc) {
			document.write('src="' + this.fURL + '"');
			this.fAddSrc = false;	// Frames are persistent
		}
		
		document.writeln(' name="' + this.fName + '" noresize scrolling=' + this.fScrolling + ' marginwidth=0 marginheight=0 frameborder=0>');
	}
}

function LayoutElement_AddContainer(name, orientation, size, visible)
{
	if (!this.fIsContainer) {
		beos.dprintf("Attempt to add frame to non container!\n");
		return null;
	}

	var element = new LayoutElement();
	element.fOrientation = orientation;
	element.fSize = size;
	element.fName = name;
	element.fIsContainer = true;
	element.fShowing = visible;
	this.fSubElements[this.fSubElements.length] = element;
	return element;
}

function LayoutElement_AddFrame(name, url, scrolling, size, visible)
{
	if (!this.fIsContainer) {
		beos.dprintf("Attempt to add frame to non container!\n");
		return null;
	}

	var element = new LayoutElement();
	element.fName = name;
	element.fURL = url;
	element.fScrolling = scrolling;
	element.fSize = size;
	element.fIsContainer = false;
	element.fShowing = visible;
	this.fSubElements[this.fSubElements.length] = element;	
	return element;
}

function LayoutElement_FindElement(name)
{
	var index;
	var element;
	
	// Check elements at this level first
	for (index = 0; index < this.fSubElements.length; index++)
		if (this.fSubElements[index].fName == name)
			return this.fSubElements[index];

	// Check children
	for (index = 0; index < this.fSubElements.length; index++) {
		element = this.fSubElements[index].FindElement(name);
		if (element != null)
			return element;
	}

	return null;
}

function LayoutElement_RemoveElement(name)
{
	var index;
	var element;
	
	// Check elements at this level first
	for (index = 0; index < this.fSubElements.length; index++)
		if (this.fSubElements[index].fName == name) {
			delete this.fSubElements[index];
			var move;
			for (move = index; move < this.fSubElements.length - 1; move++)
				this.fSubElements[move] = this.fSubElements[move + 1];
				
			this.fSubElements.length--;
			return true;			
		}

	// Check children
	for (index = 0; index < this.fSubElements.length; index++)
		if (this.fSubElements[index].RemoveElement(name))
			return true;

	return false;
}

function LayoutElement_HideElement(name)
{
	var element = this.FindElement(name);
	if (element != null)
		element.fShowing = false;
}

function LayoutElement_ShowElement(name)
{
	var element = this.FindElement(name);
	if (element != null)
		element.fShowing = true;
}

function LayoutElement_ResizeElement(name, size)
{
	var element = this.FindElement(name)
	if (element != null)
		element.fSize = size;
}

function LayoutElement_ShouldWriteHTML()
{
	if (this.fIsContainer) {
		var index;
		for (index = 0; index < this.fSubElements.length; index++)
			if (this.fSubElements[index].fIsShowing)
				return true;
	}
	
	return this.fShowing;
}

function LayoutElement_SetURL(name, url)
{
	var element = this.FindElement(name);
	if (element != null)
		element.fURL = url;
}

function LayoutElement_DeleteChildren()
{
	this.fSubElements = new Array(0);
}

LayoutElement.prototype.WriteHTML = LayoutElement_WriteHTML;
LayoutElement.prototype.AddContainer = LayoutElement_AddContainer;
LayoutElement.prototype.AddFrame = LayoutElement_AddFrame;
LayoutElement.prototype.FindElement = LayoutElement_FindElement;
LayoutElement.prototype.RemoveElement = LayoutElement_RemoveElement;
LayoutElement.prototype.HideElement = LayoutElement_HideElement;
LayoutElement.prototype.ShowElement = LayoutElement_ShowElement;
LayoutElement.prototype.ShouldWriteHTML = LayoutElement_ShouldWriteHTML;
LayoutElement.prototype.SetURL = LayoutElement_SetURL;
LayoutElement.prototype.DeleteChildren = LayoutElement_DeleteChildren;

//
//	Document wrapper that outputs debugging stuff
//
function DebugDocument_writeln(s)
{
	this.currentLine = this.currentLine + s;
	beos.dprintf(this.currentLine);
	this.currentLine = "";
}

function DebugDocument_write(s)
{
	this.currentLine = this.currentLine + s;
}

function DebugDocument()
{
	this.writeln = DebugDocument_writeln;
	this.write = DebugDocument_write;
	this.currentLine = "";
}

var debugDoc = new DebugDocument();
